searchNodes=[{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#0-0-2-2019-11-07","title":"Changelog - 0.0.2 - 2019-11-07","type":"extras","doc":"Added: rit v | rit version exposing current commit hash (short) and tag version. Changed: rit tunnel run environment fetching now prioritizes system environment variables. New precedence order: System environment variable -&gt; Input parameter -&gt; Environment parameter Fixed: Solved rit tunnel list --depth acting as length instead of depth. Solved rit tunnel list with sibling external redirections resulting in incorrect settings error. Solved rit tunnel run without --path modifier failing to link current directory with the source directory."},{"ref":"changelog.html#0-0-1-2019-11-05","title":"Changelog - 0.0.1 - 2019-11-05","type":"extras","doc":"Added: The project is available on GitLab and Hex. Notes: Minor changes (0.0.x) from the current version will be logged to this file. When a major change is released (0.x.0 or x.0.0), the changelog of the previous major change will be grouped as a single change."},{"ref":"readme.html","title":"Rit CLI","type":"extras","doc":"Rit CLI Command line tools to aid developers on daily work. At the moment, this project is not meant to be used as Elixir library, although it is possible by adding as dependency in your mix.exs file: def deps do [{:rit_cli, &quot;~&gt; 0.0.2&quot;}] end Check Rit CLI for detailed information about tools usage."},{"ref":"readme.html#installation","title":"Rit CLI - Installation","type":"extras","doc":"Self-contained Download the latest version at https://gitlab.com/ritproject/cli/-/wiki_pages/home Save it in a directory and add &lt;saved_directory&gt;/rit/bin to your PATH (or create an alias into your terminal configuration file) Running with Docker Running a single time without binding volumes: docker run -it --rm ritproject/cli help To save or bind rit configuration files: docker run -it --rm -v path/to/user/.rit:/root/.rit ritproject/cli help In order to run the majority of the functionalities of Rit CLI, you will need to bind the projects directories into container: docker run -it --rm -v host/path/to/project:/container/path/to/project -w /container/path/to/project help Note: Remember to always use the same path for each project you bind. Full command: docker run -it --rm \\ -v path/to/user/.rit:/root/.rit \\ -v host/path/to/project:/container/path/to/project \\ -w /container/path/to/project ritproject/cli help To run with docker-compose, create a docker-compose.yml file: version: &#39;3.7&#39; services: rit: image: ritproject/cli working_dir: /container/path/to/project volumes: - path/to/user/.rit:/root/.rit - host/path/to/project:/container/path/to/project Runnning with docker-compose: docker-compose run --rm rit help An example to simplify the usage of Rit CLI by binding the project on container with the same path as your machine: With docker: docker run -it --rm \\ -v path/to/user/.rit:/root/.rit \\ -v ${PWD}:${PWD} -w ${PWD} ritproject/cli help With docker-compose: version: &#39;3.7&#39; services: rit: image: ritproject/cli working_dir: ${PWD} volumes: - path/to/user/.rit:/root/.rit - ${PWD}:${PWD} You can set an alias into your terminal configuration to simplify the usage: # with docker alias rit=&#39;docker run -it --rm -v path/to/user/.rit:/root/.rit -v ${PWD}:${PWD} -w ${PWD} ritproject/cli&#39; # with docker-compose alias rit=&#39;docker-compose -f /abs/path/to/docker-compose.yml run --rm rit&#39; After fetching the terminal configuration, you can run Rit CLI normally: rit help From source code Rit ecosystem is made entirely with Elixir, which means in order to install Rit CLI source code on your machine, it is necessary to install Erlang and Elixir first. Even if it is not a common language and installing a new language on your machine is kind of a huge dependency for a simple CLI tool, Erlang and Elixir are great languages to develop with a nice community and great libraries available. If you never heard about Elixir, consider this installation as your first step into an incredible functional programming platform! Installing Erlang or Elixir To install elixir on your machine, please follow this link: https://elixir-lang.org/install.html Elixir needs Erlang and will install it on the installation process. If you just want to install Erlang, check your package manager for erlang or follow this link: http://erlang.org/doc/installation_guide/INSTALL.html Installing Rit CLI with escript Simply run: mix escript.install github ritproject/cli # or from GitLab mix escript.install git https://gitlab.com/ritproject/cli If ~/.mix/escripts are not on your PATH, consider adding it to invoke the escripts installed on your machine by name. Another option is to create an alias into your terminal configuration file: alias rit=&#39;/abs/path/to/.mix/escripts/rit&#39;"},{"ref":"tunnel.html","title":"Tunnel","type":"extras","doc":"Tunnel Tunnel is an interface to perform operations from a source directory to target directory. Source directory can be either a local directory or a git repository. With tunnel, you can: Uncouple and automate the development setup files from your project directory Improve and/or simplify CI operations Create common operations and use it everywhere Copy, fetch, or manage git ignored files to a project Etc."},{"ref":"tunnel.html#getting-started","title":"Tunnel - Getting started","type":"extras","doc":"In order to use tunnel, it is necessary to define a source directory with the command rit config tunnel add and reference it when using rit tunnel. Hello tunnel First, create a local directory to be your source: mkdir source Using your favorite text editor, create the settings file source/tunnel.yaml: version: &#39;0.0.1&#39; run: echo hello tunnel Add the tunnel source to your configuration: rit config tunnel add local source The output should be: [success] tunnel config &#39;source&#39; saved Finally, use it anywhere: rit tunnel --config source run The output will be: hello tunnel [success] tunnel successfully performed the operation Copying files To copy a source file to a target path, first create a file in source directory, such as source/secrets.py: A_SECRET = &#39;SUCH_SECRET_MUCH_WOW&#39; SOME_PRODUCTION_CONTEXT_SECRET = &#39;SOME_PRODUCTION_CONTEXT_VALUE&#39; Modify your source/tunnel.yaml: version: &#39;0.0.1&#39; run: .hello: echo hello tunnel .copy: link_dir: ./target link_mode: symlink run: cp secrets.py target/ Finally, use it anywhere: rit tunnel --config source run copy The output will be: [success] tunnel successfully performed the operation Set default source configuration To simplify the tunnel usage, you can set either a global or local default configuration. A local configuration is used whenever a --config is not defined and the target path contains a default source. A global configuration is used whenever both --config and a local configuration is not set. Both types can be set by using rit config tunnel default set. For example, to set a global default source configuration, use: rit config tunnel default set source The output will be: [success] tunnel config &#39;source&#39; set as global default To set a local default source configuration in your current directory, use: rit config tunnel default set source --path . The output will be similar to: [success] tunnel config &#39;source&#39; set as default on path &#39;/current/path&#39; To list all your tunnel source configurations, use: rit config tunnel list The output will be similar to: # Tunnels Configs - source: /path/to/source (local) ## Default Paths - (global): source - /current/path: source Finally, you can use rit tunnel without the --config modifier: rit tunnel run hello Additional settings Please check the section below to discover all the parameters and operators available to use in a YAML settings file."},{"ref":"tunnel.html#settings-parameters-and-settings-operators","title":"Tunnel - Settings parameters and Settings operators","type":"extras","doc":"Settings parameters allows to configure how the operation will be performed. Settings operators allows to define the operation itself. Settings parameters environment Set one or more environment variables to be used by any of the children operators. Pattern: environment: [&lt;ENV_NAME&gt;: &lt;ENV_VALUE&gt;]+ Examples: environment: NODE_ENV: production run: yarn build environment: PARSE_FILES: &#39;true&#39; EXPORT_AS: json run: ./parser $PARSE_FILES $EXPORT_AS input Set one or more environment variables that can be defined by the user before performing a operation. Ensure defaults_to is set to avoid errors when executing operations without input enabled. Pattern: input: [&lt;KEY&gt;: environment_name: &lt;ENV_NAME&gt; defaults_to: &lt;ENV_VALUE&gt;]+ Examples: input: NODE_ENV: defaults_to: production run: yarn build input: parse_files?: environment_name: PARSE_FILES defaults_to: &#39;true&#39; export_as: environment_name: EXPORT_AS defaults_to: json run: ./parser $PARSE_FILES $EXPORT_AS link_dir Set the path relative to the current settings directory to fetch the files from target directories. The fetch will be performed only if both link_dir and link_mode are set. Pattern: link_dir: &lt;LINK_DIR&gt; Examples: link_dir: ./app link_mode: copy run: docker-compose up link_dir: ./data_source link_mode: symlink run: cp data.csv data_source/ link_mode Set how to fetch the target at link_dir. The fetch will be performed only if both link_dir and link_mode are set. Options: copy: Copy the target to the tunnel directory. Use it whenever you want to ensure the state of the target directory will not change. symlink: Create a symbolic link at the tunnel directory. Use it whenever you want to change the state of the target directory. none (default): Do not perform any tunnel. Use it whenever you want to perform operations without the need to bind directories. Pattern: link_mode: &lt;copy|symlink|none&gt; Examples: link_dir: ./app link_mode: copy run: docker-compose up link_dir: ./data_source link_mode: symlink run: cp data.csv data_source/ link_mode: none run: echo hello world Settings operators An operation can be either a command or a list of commands. .argument An argument operator is used to set a graph to define multiple operations. A child argument inherit all the parameters set in all its parents. A sibling argument shares the parameters from its parents and from the current context. Pattern: .&lt;ARG_NAME&gt;: ... [.&lt;CHILD_ARG_NAME&gt;: ...]* [.&lt;SIBLING_ARG_NAME&gt;: ...]* Example: run: .hello: run: echo hello .world: run: echo world .name: input: NAME: defaults_to: Jon SURNAME: defaults_to: Doe direct: echo $NAME $SURNAME .joana: echo Joana $SURNAME .snow: echo $NAME Snow $ rit tunnel run hello hello $ rit tunnel run hello world hello world $ rit tunnel run hello name hello Jon Doe $ rit tunnel run hello name joana hello Joana Doe $ rit tunnel run hello name snow hello Jon Snow direct An direct operator is used to set a operation that will be executed ONLY if the arguments received is exactly the same as the path to the parent argument operator. If the path continues, it will not be executed. Pattern: direct: [&lt;COMMAND&gt;]+ Example: run: .hello: direct: echo hello .world: direct: echo world .there: direct: - echo hello there - echo general Kenobi! $ rit tunnel run hello hello $ rit tunnel run hello world world $ rit tunnel run hello there hello there general Kenobi! redirect An redirect operator is an special operation used to redirect the current path to another path or to another settings file. If strict option is set to true, it will execute only the command defined in the last argument set by to option. Pattern: redirect: to: &lt;INTERNAL_OR_EXTERNAL_PATH&gt; external: &lt;true|false (default)&gt; strict: &lt;true|false (default)&gt; Internal example: run: .hello: run: echo hello .world: run: echo world .hi: redirect: to: hello .goodbye: .forever: echo goodbye .swag: echo hasta la vista, baby .nvm: redirect: to: hello world strict: true $ rit tunnel run hello hello $ rit tunnel run hello world hello world $ rit tunnel run hi hello $ rit tunnel run hi world hello world $ rit tunnel run goodbye forever goodbye $ rit tunnel run goodbye swag hasta la vista, baby $ rit tunnel run goodbye nvm world External example: example ├── tunnel.yml └── outsider └── tunnel.yml # example/tunnel.yml run: .hello: run: echo hello .world: run: echo world .outsider: redirect: to: outsider external: true # example/outsider/tunnel.yml run: direct: echo what? .ola: echo ola! $ rit tunnel hello hello $ rit tunnel hello world hello world $ rit unnel hello outsider hello what? $ rit tunnel hello outsider ola hello ola! run Run is the basic operator type and will be run whenever its path is a subset of the arguments, except on strict redirect. A root run operator must be set in each settings file, otherwise rit will fail."}]